#This script converts all rasters to polygons, joins the final processed roads to counties and then creates indicator if flooded

import arcpy
arcpy.env.overwriteOutput = True

#set file paths
#arcpy.env.workspace = r'X:\GIS\Projects\SLR_National_Model\Analysis\2019a Nuisance Flooding\NOAA Flood Frequency Maps 2018\Flood_Frequency_data_dist_Sweet2018\FINAL_HTF_Minor.gdb'
path = "X:\GIS\Projects\SLR_National_Model\Analysis\\2019a Nuisance Flooding\IEC GIS\State Runs"
countyShp = "X:\GIS\Projects\SLR_National_Model\Analysis\\2019a Nuisance Flooding\IEC GIS\Shapefiles\Counties_in_modelFIPS.shp"
ffFold = "X:\GIS\Projects\SLR_National_Model\Analysis\\2019a Nuisance Flooding\IEC GIS\Flood Frequency\Merged 2018 rasters"

#convert all raster FF to polygon
#for fc in arcpy.ListDatasets():
    #arcpy.RasterToPolygon_conversion(in_raster=fc, out_polygon_features="X:/GIS/Projects/SLR_National_Model/Analysis/2019a Nuisance Flooding/IEC GIS/Flood Frequency/Merged 2018 rasters/" + fc +".shp", simplify="NO_SIMPLIFY", raster_field="Value")

#create list of coastal states
coastStDict = {'alabama':'al','california':'ca','connecticut':'ct','delaware':'de','district':'dc','florida':'fl','georgia':'ga','louisiana':'la','maine':'me','maryland':'md','massachusetts':'ma','mississippi':'ms','newhampshire':'nh','newjersey':'nj','newyork':'ny','northcarolina':'nc','oregon':'or','pennsylvania':'pa','rhodeisland':'ri','southcarolina':'sc','texas':'tx','virginia':'va','washington':'wa'}

#set analyses
analyses = ['1_2','3_7']

for state in coastStDict:
    for a in analyses:
        print state
        #set file path to final FC file
        fc = path + "/"+ state + "_" + a + "/FC" + a "_WAADT_Diss.shp"

        #spatial join to counties grid for FIPS code
        fc_join = path + "/"+ state + "_" + a + "/FC" + a "_WAADT_Diss_joinFIPS.shp"
        arcpy.SpatialJoin_analysis(fc, countyShp, fc_join, "", "", "", "WITHIN","","")
        
        #add field for indicator flood variable
        arcpy.AddField_management(fc_join, "FldInd", "SHORT")

        #feed in flood frequency raster
        #path of raster... use dictionary key to summon the abbreviation of the state.
        ffRast = ffFold + "\\"+ coastStDict[state] + "_htf_minor.shp"
        
        #select each roads layer by raster
        #calculate FldInd field where 1 == flooded
        arcpy.MakeFeatureLayer_management(fc_join, "fcjoin")
        arcpy.SelectLayerByLocation_management("fcjoin", "INTERSECT", ffRast)
        arcpy.CalculateField_management("fcjoin", "FldInd", 1)

        if a == '1_2':
            ramp = path + "/"+ state + "_1_2" + "/ramps.shp"
            #select each roads layer by raster
            #calculate RampInd field where 1 == ramp
            #add field for indicator flood variable
            arcpy.AddField_management(fc_join, "RampInd", "SHORT")
            arcpy.MakeFeatureLayer_management(fc_join, "fcramp")
            arcpy.SelectLayerByLocation_management("fcramp", "HAVE_THEIR_CENTER_IN", ramp)
            arcpy.CalculateField_management("fcramp", "RampInd", 1)

        #remove all layers from data frame
        mxd = arcpy.mapping.MapDocument("CURRENT")
        df = arcpy.mapping.ListDataFrames(mxd)[0]
        for lyr in arcpy.mapping.ListLayers(mxd,"",df):
            arcpy.mapping.RemoveLayer(df,lyr)
        
