#Buffer bridge analysis ONLY for GA

import arcpy
import os

arcpy.env.overwriteOutput = True
env = "X:/GIS/Projects/SLR_National_Model/Analysis/2019a Nuisance Flooding/"

arcpy.ImportToolbox("C:\Program Files (x86)\ET SpatialTechniques\ET GeoWizards 11.4 for ArcGis 10.4\ET GeoWizards.tbx")
ETGWPath = "C:\Program Files\ETSpatialTechniques\ETGeoWizards\ETGWRun.exe"

#PARAMETERS
origID = "OrigRd_ID"
segID = "Seg_ID"
shp = ".shp"
hpmsData = "Original GIS Files/HPMS 2016"
outData = "IEC GIS/State Runs"
spatRef = "USA Contiguous Equidistant Conic"
countyData = "IEC GIS/Shapefiles/Counties_in_model.shp"

hpms = env + hpmsData #create file path of HPMS 2016 data
path = env + outData #create file path for output data
ffFold = "X:\GIS\Projects\SLR_National_Model\Analysis\\2019a Nuisance Flooding\IEC GIS\Flood Frequency\Merged 2018 rasters"
coastCnt = env + countyData
sr = arcpy.SpatialReference(spatRef) #establish projected coordinate system

#set analyses
analyses = ['1_2','3_7']

#set buffer distance
buffDist = 200

#initialize vector of coastal states
coastSt = {'alabama':'al','california':'ca','connecticut':'ct','delaware':'de','district':'dc','florida':'fl','louisiana':'la','maine':'me','maryland':'md','massachusetts':'ma','mississippi':'ms','newhampshire':'nh','newjersey':'nj','newyork':'ny','northcarolina':'nc','oregon':'or','pennsylvania':'pa','rhodeisland':'ri','southcarolina':'sc','texas':'tx','virginia':'va','washington':'wa'}

### Georgia bridge analysis done manually
ga = {'georgia':'ga'}

#loop over all states
for g in ga:
    for a in analyses:
        print g
        print a

        #create file path of final join layer    
        statePath = path + "/"+ g + "_" + a #create state folder path
        fc = statePath + "/FC" + a + shp
        
        #Select bridges
        BTC = statePath + "/FC" + a + "BTC" + shp
        #arcpy.MakeFeatureLayer_management(fc, "selectBTC", '"STRUCTURE_"<>0')
        #arcpy.CopyFeatures_management("selectBTC", BTC)    

        #Buffer bridges
        buffBTC = path + "/"+ g + "_1_2" + "/BTC_all_Buff.shp"
        buffer = str(buffDist) + 'Feet'
        #arcpy.Buffer_analysis(BTC, buffBTC, buffer)

        #erase from final segment
        joinFIPS = statePath + "/FC" + a + "_WAADT_Diss_joinFIPS" + shp
        eraseBTC = statePath + "/FC" + a + "_erase_bufferBTC_" + str(buffDist) + shp
        arcpy.ET_GPErase(joinFIPS, buffBTC, eraseBTC, 1)

        #dissolve erased buffer bridges
        dissErase = statePath + "/FC" + a + "_erase_bufferBTC_" + str(buffDist) + "_diss" + shp
        if a == "1_2":
            dissField = ["Seg_ID","LENGTH_1","F_SYSTEM", "SUM_VMT", "W_AADT", "FIPS", "RampInd"]
        else:
            dissField = ["Seg_ID","LENGTH_1","F_SYSTEM", "SUM_VMT", "W_AADT", "FIPS"]
        arcpy.Dissolve_management(eraseBTC, dissErase, dissField, "","","DISSOLVE_LINES")
            
        #make additional bufferFld field
        arcpy.AddField_management(dissErase, "BuffFld", "FLOAT")

        #calculate buffFld field where 1 == flooded    
        ffRast = ffFold + "\\"+ ga[g] + "_htf_minor.shp"
        arcpy.MakeFeatureLayer_management(dissErase, "noBTC")
        arcpy.SelectLayerByLocation_management("noBTC", "INTERSECT", ffRast)
        arcpy.CalculateField_management("noBTC", "BuffFld", 1)
        
        #remove all layers from data frame
        mxd = arcpy.mapping.MapDocument("CURRENT")
        df = arcpy.mapping.ListDataFrames(mxd)[0]
        for lyr in arcpy.mapping.ListLayers(mxd,"",df):
            arcpy.mapping.RemoveLayer(df,lyr)