#This script lists out all county .mdb grids, selects processed roads by the county and spatial joins the road to the NCPM grids
#join road segments to NCPM grids


import arcpy
import os
arcpy.env.overwriteOutput = True

#set file paths
access = "X:\\GIS\\Projects\\SLR_National_Model\\Analysis\\2019a Nuisance Flooding\\IEC GIS\\Access Files"
mdb = ".mdb"
runs = "X:\\GIS\\Projects\\SLR_National_Model\\Analysis\\2019a Nuisance Flooding\\IEC GIS\\State Runs\\"
outFold = "X:\\GIS\\Projects\\SLR_National_Model\\Analysis\\2019a Nuisance Flooding\\IEC GIS\\Access Files\\county join roads\\"

#set analyses
analyses = ['1_2','3_7']

#set state dictionary with abbreviations
coastSt = {'AL':'alabama','CA':'california','CT':'connecticut','DE':'delaware','DC':'district','FL':'florida','GA':'georgia','LA':'louisiana','ME':'maine','MD':'maryland','MA':'massachusetts','MS':'mississippi','NH':'newhampshire','NJ':'newjersey','NY':'newyork','NC':'northcarolina','OR':'oregon','PA':'pennsylvania','RI':'rhodeisland','SC':'southcarolina','TX':'texas','VA':'virginia','WA':'washington'}


files = []
counties = []
iter = 0


for r,d,f in os.walk(access):
    for file in f:
        #create vector of all counties
        if '.mdb' in file:
            #create vector of all county grid mdbs
            counties.append(f[iter][:-4])           
        iter += 1

print counties

#create file paths to grid feature class
for c in counties:
    for a in analyses:
        print c
        print a
        
        file = access + "\\" + c + mdb + "\\" + c + "_Final_Grid"
        shpFold = "X:\\GIS\\Projects\\SLR_National_Model\\Analysis\\2019a Nuisance Flooding\\IEC GIS\\Access Files\\shapefile grids\\"
        outName = c + "_Final_Grid"
        #arcpy.FeatureClassToFeatureClass_conversion(file, shpFold, outName)

        #create file paths for final road segs
        fc = runs + str(coastSt[c[:2]]) + "_" + a + "\\FC" + a + "Diss_Split.shp"

        #create file paths for output join
        fc_join = outFold + c + "_FC" + a + "_gridJoin"

        #spatial join fc
        countyGrid = shpFold + outName + ".shp"
        arcpy.MakeFeatureLayer_management(countyGrid, "countyGrid")
        arcpy.SelectLayerByLocation_management("countyGrid", "INTERSECT",fc)
        arcpy.SpatialJoin_analysis("countyGrid", fc, fc_join)

        #remove all layers from data frame
        mxd = arcpy.mapping.MapDocument("CURRENT")
        df = arcpy.mapping.ListDataFrames(mxd)[0]
        for lyr in arcpy.mapping.ListLayers(mxd,"",df):
            arcpy.mapping.RemoveLayer(df,lyr)
